import { publishEvent } from './publish.js';
export async function getProfileEvent(client, pubkey) {
    const filter = {
        authors: [pubkey],
        kinds: [0]
    };
    let timer;
    return new Promise((resolve, reject) => {
        timer = setTimeout(() => {
            reject(new Error('Profile request timed out!'));
        }, 5000);
        void client.get(filter).then(event => {
            clearTimeout(timer);
            resolve((event?.content !== undefined)
                ? JSON.parse(event.content)
                : undefined);
        });
    });
}
export async function setProfileEvent(client, profile, signer) {
    const template = {
        tags: [],
        content: JSON.stringify(profile),
        kind: 0,
        created_at: Math.floor(Date.now() / 1000)
    };
    return publishEvent(client, template, signer)
        .then(res => JSON.parse(res.content));
}
//# sourceMappingURL=profile.js.map