import { now } from './util.js';
export async function publishEvent(client, event, signer) {
    const signed = await signer({
        kind: 20000,
        tags: [],
        content: '',
        ...event,
        created_at: now()
    });
    const pub = await client.pub(signed);
    let timer;
    function resolver() {
        clearTimeout(timer);
        return signed;
    }
    return new Promise((resolve, reject) => {
        pub.on('ok', () => { resolve(resolver()); });
        pub.on('failed', () => { reject(new Error('Failed to publish event.')); });
        timer = setTimeout(() => { reject(new Error('Event publishing timed out!')); }, 5000);
    });
}
//# sourceMappingURL=publish.js.map