import { ReactElement } from 'react';
import { useNostrStore } from './hooks/useNostr.js';
import { DEFAULT } from './schema/config.js';
export * from './schema/types.js';
export type NostrContext = ReturnType<typeof useNostrStore>;
export declare function NostrProvider({ children, defaults }: {
    children: ReactElement | ReactElement[];
    defaults?: Partial<typeof DEFAULT.store>;
    hooks?: Partial<typeof DEFAULT.hooks>;
}): ReactElement;
export declare function useNostr(): {
    joinRoom: (secret: string, config?: Partial<import("./lib/room.js").RoomConfig> | undefined) => import("./lib/room.js").NostrRoom;
    getProfile: () => Promise<import("./schema/types.js").Profile | undefined>;
    setProfile: (updates: Partial<import("./schema/types.js").Profile>) => Promise<void>;
    login: {
        withExt: () => Promise<void>;
        withPubKey: (pubkey: string) => void;
        withSecKey: (seckey: string) => void;
        generateKey: () => void;
    };
    logout: () => void;
    client: {
        connected: () => Promise<boolean>;
        publish: (event: Partial<import("nostr-tools").EventTemplate>) => Promise<import("nostr-tools").Event | undefined>;
        pubkey: string | undefined;
        ok: boolean;
        get: (filter: import("nostr-tools").Filter) => Promise<import("nostr-tools").Event<import("nostr-tools").Kind> | null>;
        list: (filters: import("nostr-tools").Filter[]) => Promise<import("nostr-tools").Event<import("nostr-tools").Kind>[]>;
        pub: (event: import("nostr-tools").Event) => Promise<import("nostr-tools").Pub>;
        sub: (filters: import("nostr-tools").Filter[]) => Promise<import("nostr-tools").Sub<import("nostr-tools").Kind>>;
    };
    setError: (err: string | Error) => void;
    reset: (store: Partial<import("./schema/types.js").NostrStore>) => void;
    store: import("./schema/types.js").NostrStore;
    update: (store: Partial<import("./schema/types.js").NostrStore>) => void;
};
//# sourceMappingURL=index.d.ts.map