import { Buff, Json } from '@cmdcode/buff-utils';
import { Event, EventTemplate, Filter, Sub } from 'nostr-tools';
import { Client } from '../schema/types.js';
export interface RoomConfig {
    cacheSize: number;
    allowEcho: boolean;
    encryption: boolean;
    expiration: number;
    filter: Filter;
    inactiveLimit?: number;
    kind: number;
    tags: string[][];
}
export declare class NostrRoom {
    readonly cache: Array<[eventName: string, payload: any, envelope: Event]>;
    readonly client: Client;
    readonly config: RoomConfig;
    readonly events: Record<string, Set<Function>>;
    readonly _secret: Buff;
    connected: boolean;
    _sub?: Sub;
    constructor(client: Client, secret: string, config?: Partial<RoomConfig>);
    get members(): string[];
    get roomId(): Buff;
    get shareKey(): Buff;
    _subscribe(): Promise<void>;
    _eventHandler(event: Event): Promise<void>;
    _getFn(eventName: string): Set<Function>;
    emit(eventName: string, ...args: any[]): void;
    pub(eventName: string, payload: Json, template?: Partial<EventTemplate>): Promise<Event | undefined>;
    on(eventName: string, fn: Function): void;
    once(eventName: string, fn: Function): void;
    within(eventName: string, fn: Function, timeout: number): void;
    remove(eventName: string, fn: Function): void;
    prune(eventName: string): void;
    leave(): void;
}
//# sourceMappingURL=room.d.ts.map